<template>
  <q-page class="flex-center">
    <q-table
      :rows-per-page-options="[15, 25, 50]"
      :data="data"
      :columns="columns"
      separator="cell"
      :filter="filter"
      :pagination.sync="pagination"
      row-key="id"
    >
      <template slot="top" slot-scope="props">
        <q-btn
          push
          rounded
          color="primary"
          icon="add"
          @click="add()"
          v-show="is_super_admin"
          >Add Staff</q-btn
        >
        <div class="col" />
        <div>
          <q-toolbar class="bg-primary text-back rounded-borders">
            <q-input
              dark
              dense
              standout
              v-model="filter"
              input-class="text-right"
              class="q-ml-md"
            >
              <template v-slot:append>
                <q-icon v-if="filter === ''" name="search" />
                <q-icon
                  v-else
                  name="clear"
                  class="cursor-pointer"
                  @click="filter = ''"
                />
              </template>
            </q-input>
          </q-toolbar>
        </div>
      </template>
      <q-tr slot="body" slot-scope="props" :props="props">
        <q-td
          key="No"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
          >{{ props.row.No }}</q-td
        >
        <q-td
          key="role"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.role_name }}</q-td
        >
        <q-td
          key="name"
          :props="props"
          :style="{ width: '200px', whiteSpace: 'normal' }"
          >{{ props.row.name }}</q-td
        >
        <q-td
          key="username"
          :props="props"
          :style="{ width: '100px', whiteSpace: 'normal' }"
          >{{ props.row.username }}
        </q-td>
        <!-- <q-td key="phone" :props="props" :style="{width: '100px', whiteSpace: 'normal'}">{{ props.row.phone }}</q-td>         -->
        <q-td
          key="status"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <q-toggle
            v-model="props.row.status"
            :false-value="0"
            :true-value="1"
            v-show="is_super_admin"
            @input="ChangeStatus(props.row)"
          ></q-toggle>
        </q-td>
        <q-td
          key="action"
          :props="props"
          :style="{ width: '20px', whiteSpace: 'normal' }"
        >
          <div class="row items-center justify-left no-wrap">
            <q-btn
              size="sm"
              round
              rounded
              color="secondary"
              icon="edit"
              @click="load(props.row)"
              class="q-mr-xs"
              v-show="is_super_admin"
            />
            <q-btn
              size="sm"
              round
              rounded
              color="negative"
              icon="delete"
              @click="remove(props.row)"
              class="q-mr-xs"
              v-show="is_super_admin"
            />
          </div>
        </q-td>
      </q-tr>
    </q-table>
    <!-- add -->
    <q-dialog
      v-model="modal_add"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Role" prop="role">
              <q-select
                filled
                v-model="form.role"
                :options="options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input v-model="form.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input v-model="form.username" autocomplete="off"></el-input>
            </el-form-item>
            <!-- <el-form-item label="Phone" prop="phone">
              <el-input v-model="form.phone" autocomplete="off"></el-input>
            </el-form-item>             -->
            <el-form-item label="Password" prop="password">
              <el-input
                type="password"
                v-model="form.password"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <el-form-item label="Confrim" prop="confrim">
              <el-input
                type="password"
                v-model="form.confrim"
                autocomplete="off"
              ></el-input>
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="insert()"
            v-show="is_super_admin"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- update -->
    <q-dialog
      v-model="modal_edit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form_edit"
            ref="form_edit"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Role" prop="role">
              <q-select
                filled
                v-model="form_edit.role"
                :options="options"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Name" prop="name">
              <el-input v-model="form_edit.name" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="Username" prop="username">
              <el-input
                v-model="form_edit.username"
                autocomplete="off"
              ></el-input>
            </el-form-item>
            <!-- <el-form-item label="Phone" prop="phone">
              <el-input v-model="form_edit.phone" autocomplete="off"></el-input>
            </el-form-item>                                   -->
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn
            push
            rounded
            color="primary"
            @click="Update()"
            v-show="is_super_admin"
            >Submit</q-btn
          >
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "Staff",
  data() {
    var validatePass = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password"));
      } else {
        if (this.form.confrim !== "") {
          this.$refs.form.validateField("confrim");
        }
        callback();
      }
    };
    var validatePass2 = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("Please input the password again"));
      } else if (value !== this.form.password) {
        callback(new Error("Two inputs don't match!"));
      } else {
        callback();
      }
    };
    return {
      data: [],
      search: "",
      columns: [
        {
          name: "No",
          label: "No",
          field: "No",
          align: "left",
          stortable: true
        },
        {
          name: "role",
          label: "Role",
          field: "role",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "name",
          label: "Name",
          field: "name",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "username",
          label: "Username",
          field: "username",
          require: true,
          align: "left",
          stortable: true
        },
        // { name: 'phone', label: 'Phone', field: 'phone', require: true, align: 'left', stortable: true },
        {
          name: "status",
          label: "Status",
          field: "status",
          require: true,
          align: "left",
          stortable: true
        },
        {
          name: "action",
          label: "Action",
          field: "id",
          require: true,
          align: "left",
          stortable: true
        }
      ],
      filter: "",
      separator: "horizontal",
      pagination: {
        sortBy: null,
        descending: false,
        page: 1,
        rowsPerPage: 10
      },
      modal_edit: false,
      modal_add: false,
      form: {
        role: "",
        name: "",
        username: "",
        password: "",
        confrim: "",
        phone: ""
      },
      form_edit: {},
      rules: {
        role: [
          { required: true, message: "Please select role", trigger: "change" }
        ],
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        username: [
          { required: true, message: "Please input username", trigger: "blur" }
        ],
        password: [
          { required: true, validator: validatePass, trigger: "blur" }
        ],
        confrim: [
          { required: true, validator: validatePass2, trigger: "blur" }
        ],
        phone: [
          { required: true, message: "Please input phone", trigger: "blur" }
        ]
      },
      rules_edit: {
        role: [
          { required: true, message: "Please select role", trigger: "change" }
        ],
        name: [
          { required: true, message: "Please input name", trigger: "blur" }
        ],
        username: [
          { required: true, message: "Please input user", trigger: "blur" }
        ],
        phone: [
          { required: true, message: "Please input phone", trigger: "blur" }
        ]
      },
      options: [],
      btn: [
        { label: "Disable", color: "red" },
        { label: "Enable", color: "primary" }
      ],
      is_super_admin: this.$q.sessionStorage.getItem("role") <= 1 ? true : false
    };
  },

  async created() {
    await this.getdata();
    await this.getrole();
  },

  methods: {
    async getdata(pageNumber) {
      try {
        this.data = await this.$services.staff.read({});
        this.$services.updateindex(this.data);
      } catch (e) {
        this.$services.error(e.response);
      }
    },

    async getrole() {
      let ctx = this;
      this.options = [];
      this.$services.role
        .read()
        .then(function(data) {
          data.forEach(row => {
            if (row.level <= 1) {
              ctx.options.push({ value: row.id, label: row.name });
            }
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response);
        });
    },

    add() {
      this.modal_add = true;
      this.form = {
        name: "",
        username: "",
        password: "",
        confrim: "",
        phone: "",
        role: ""
      };
    },

    async insert() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$services.staff
            .add(this.form)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_add = false;
              ctx.$services.success("Save Staff Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response);
            });
        }
      });
    },

    load(row) {
      this.form_edit = row;
      this.modal_edit = true;
    },

    async Update() {
      let ctx = this;
      this.$refs.form_edit.validate(valid => {
        if (valid) {
          this.$services.staff
            .update(this.form_edit, this.form_edit.id)
            .then(function(data) {
              ctx.getdata();
              ctx.modal_edit = false;
              ctx.$services.success("Update Staff Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response);
            });
        }
      });
    },

    async remove(row) {
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want to Staff ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.staff
            .remove(row.id)
            .then(function(e) {
              ctx.getdata();
              ctx.$services.success(
                "Delete Staff Name " + row.name + " Success"
              );
            })
            .catch(function(e) {
              ctx.$services.error(e.response);
            });
        })
        .onCancel(() => {
          // console.log('>>>> Cancel')
        });
    },

    ChangeStatus(row) {
      const prev = row.status == 0 ? 1 : 0;
      let ctx = this;
      this.$q
        .dialog({
          title: "Confirm",
          message: `Do you really want Change Status to Staff ${row.name} later, ok?`,
          ok: {
            push: true
          },
          cancel: {
            push: true,
            color: "negative"
          },
          persistent: true
        })
        .onOk(() => {
          this.$services.staff
            .update(row, row.id)
            .then(function(data) {
              ctx.getdata();
              ctx.$services.success("Update Staff Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response);
              row.status = prev;
            });
        })
        .onCancel(() => {
          row.status = prev;
          // console.log('>>>> Cancel')
        });
    }
  }
};
</script>

<style lang="stylus"></style>
